// -*- Mode: c++ -*-
// $Id: MeshFilter.cpp,v 1.6 2000/04/28 22:14:21 ps Exp $
// $Source: /ufs/multires/projects//src/meshfilter/MeshFilter.cpp,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech)
 *
 * April 26, 2000
 * All Rights Reserved
 *
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 *
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#include "Mesh.h"
#include "compat.h"

#include <string.h>

const char *usage = "mfilter DS|BIQ\n\tinput is expected on stdin and output on stdout\n";

int
main(int argc, char ** argv){
  if( argc < 2 ){
    cerr << usage;
    exit(1);
  }
  const Scheme sch = !strcmp(argv[1], "DS") ? DS : BIQ;
  Mesh mesh(sch);
  if( !readIVFile( stdin, mesh ) ){
    cerr << usage;
    exit(1);
  }
  mesh.Subdiv();
  cout << mesh;

  return 0;
}
