// -*- Mode: c++ -*-
// $Id: V4Vert.cpp,v 1.4 2000/04/28 22:14:21 ps Exp $
// $Source: /ufs/multires/projects//src/meshfilter/V4Vert.cpp,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech)
 *
 * April 26, 2000
 * All Rights Reserved
 *
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 *
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#include "V4Vert.h"
#include "Vert.h"

V4Vert::V4Vert(Vert * v)
  : m_p(v){
  assert(v);
  m_l = v->Loc();
  m_n[N] = m_n[W] = m_n[S] = m_n[E] = 0;
  m_d[NW] = m_d[SW] = m_d[SE] = m_d[NE] = 0;
}

V4Vert::~V4Vert()
{
  // unlink from the parent. the parent is going to take care of cleaning
  // up everything including this V4Vert
  m_p = NULL;
}
