// -*- Mode: c++ -*-
// $Id: CFace.h,v 1.7 2000/04/28 22:14:43 ps Exp $
// $Source: /ufs/multires/projects//src/CourseQuad/CFace.h,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech) 
 *
 * April 26, 2000
 * All Rights Reserved
 * 
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 * 
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#ifndef __CFACE_H
#define __CFACE_H

#include <vector>
#include "compat.h"

class Cp;
class CVec;
class QTree;

class CFace{
 public:
  // the Cps that consitute this face in CCW or CW and the number of Cps
  CFace(Cp * cps[], unsigned int sides);
  ~CFace();

  // the Cps
  std::vector<Cp*>& CPs( void ) { return m_cpc; }
  CVec* c( void ) const { return cent; }
  // link Cps up
  void BuildTopology( void );
  // flip links when necessary
  void ConfigLinks( void );

 private:
  std::vector<Cp *> m_cpc;
  CVec * cent;
};

#endif /* __CFACE_H */
