##############################################################################
#
# Makefile for dual code
#
#
# $Id: Makefile.CC,v 1.11 2000/04/28 22:14:46 ps Exp $
# $Source: /ufs/multires/projects//src/CourseQuad/Makefile.CC,v $
#


##############################################################################
# This file defines the following targets:
# ===========================================================================
# <null target> or all: makes your application.
#
# libs:  makes userinterface library (libqv.a)
#
# clean: removes all the usual stuff (if your Makefile is checked in, it will
#        be removed too... you might then want to do a "co Makefile")
#
# tags: creates emacs style TAGS file
#
# ctags: creates vi style TAGS file
#
############################################################################## 

SHELL = /bin/sh
##############################################################################
# Application file definitions -- EDIT THESE
##############################################################################

# You may need to make sub-definitions for these definitions if you have
# multiple languages, or other requirements.

# All your source files
SWSRCS= Cp.cpp\
        cvec.cpp\
        OneRing.cpp\
        Perms.cpp\
        QTree.cpp\
        CFace.cpp\
        CMesh.cpp

SRCS=$(SWSRCS) $(ARCHSRCS)

# C-language source, to compile with cc
SWCSRCS= 
CSRCS=$(SWCSRCS) $(ARCHCSRCS)

# source files with no associated .o 
SRCSNOO= Subdiv.cpp

# source files with no associated .h 
SRCSNOH= 

HDRSNOS=Names.h\
	util.h\
	real.h\
	compat.h

# sources that are #include'd, and have no associated .o
TABLESRCS=

ALLSRCS=$(SRCSNOH) $(CSRCS) $(SRCS) $(SRCSNOO) $(TABLESRCS) 

# All the local .h files (these are not automatically depended)
HDRS=$(HDRSNOS) ${SRCS:.cpp=.h} ${CSRCS:.c=.h} ${SRCSNOO:.cpp=.h}

# All .o files generated
COBJS=${CSRCS:.c=.o}
OBJS= $(COBJS) ${SRCS:.cpp=.o}
ALLOBJS=$(OBJS) ${SRCSNOH:.cpp=.o}

# Man pages, etc. (leave blank if none)
DOCS=

# Application name
TARGET= dual

##############################################################################
# Application-specific definitions  -- EDIT THESE
##############################################################################

#include directories
INCS = -I. -I../qvlib/include

# cc flags
CDEF = -ansi -fullwarn

# CC flags
CCDEF= -ansi -fullwarn

DEBUG= -g

# C specific options
COPTS=

# C++ specific options
CCOPTS= -MDupdate Makedepend.CC

# linker options
LIBS= -lm -L../qvlib/src -lqv 

# ----------------------------------------------------------------------------
# -- You shouldn't need to edit anything below here, unless you have more
# -- than one target or are building a library, or you're doing something
# -- nonstandard.
# ----------------------------------------------------------------------------

##############################################################################
# Language definitions
##############################################################################

CFLAGS= $(INCS) $(CDEF) $(DEBUG) $(COPTS) 
CCFLAGS=$(INCS) $(CCDEF) $(DEBUG) $(CCOPTS)

CC=CC
cc=cc

TARGET_COMPILER_FLAGS=$(CCFLAGS) $(LIBOPTS)
TARGET_COMPILER=$(CC)

##############################################################################
# extra default rules
##############################################################################

.SUFFIXES: .C .cpp .c

.cpp:
	$(CC) $(CCFLAGS) -o $@ $<

.C:
	$(CC) $(CFLAGS) -o $@ $<

.c:
	$(cc) $(CFLAGS) -o $@ $<

.C.o:
	$(CC) $(CCFLAGS) -c $<

.cpp.o:
	$(CC) $(CCFLAGS) -c $<

.c.o:
	$(cc) $(CFLAGS) -c $<

# This rule must be first.  It insures that the desired target is the default.

all: libs $(TARGET) 


##############################################################################
# Application-specific rules and dependencies - may need editing
##############################################################################

docs:
	cd doc/; make all

libs:
	cd ../qvlib/src; make -f Makefile.CC CC=$(CC) cc=$(cc)

$(TARGET): Subdiv.o $(ALLOBJS)
	@echo Compiling $@
	$(TARGET_COMPILER) -o $(TARGET) $(TARGET_COMPILER_FLAGS) \
		 Subdiv.o $(ALLOBJS) $(LIBS) 
	@echo $@ is made.


##############################################################################
# General-purpose targets - do not edit, in general:
##############################################################################

tags:
	etags $(ALLSRCS) $(HDRS)

ctags:
	ctags $(ALLSRCS) $(HDRS)

clean:	
	rm -f $(TARGET) $(OBJS) *.slo *.o *~ *.s \
		*.a *..c TAGS core a.out \#* *.bak *.BAK *.CKP \
		*.l *.Addrs *.Counts *.pixie .\#* ii_files/*; 
	rm -f Makedepend.CC; touch Makedepend.CC;
	cd ../qvlib/src; make -f Makefile.CC clean;

.IGNORE:    

include Makedepend.CC
