// -*- Mode: c++ -*-
// $Id: Names.h,v 1.6 2000/04/28 22:14:46 ps Exp $
// $Source: /ufs/multires/projects//src/CourseQuad/Names.h,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech) 
 *
 * April 26, 2000
 * All Rights Reserved
 * 
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 * 
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#ifndef	__NAMES_H__
#define	__NAMES_H__

#include "compat.h"

// unfortunately we need to fix the maximum depth of trees and there are
// other places than just trees who need to know about this...
#define __MAXDEPTHLENGTH 5
#define __MAXDEPTH (1<<__MAXDEPTHLENGTH)
// for now we limit faces to have no more than 32 vertices
#define	__MAXFACESIZE 32

enum Direction    { N = 0,  W = 1,  S = 2,  E = 3 };
enum QTreeName    { NW = 0, SW = 1, SE = 2, NE = 3 };
enum Scheme       { DS = 0, ME = 1, BIQ = 2 };

inline Direction Prev( const Direction d ) { return Direction((d+3)%4); }
inline Direction Next( const Direction d ) { return Direction((d+1)%4); }
inline Direction Oppos (const Direction d ) { return Direction((d+2)%4); }
inline Direction First( const QTreeName d ) { return Direction(d); }
inline Direction Second( const QTreeName d ) { return Direction((d+1)%4); }
inline QTreeName Prev( const QTreeName d ) { return QTreeName((d+3)%4); }
inline QTreeName Next( const QTreeName d ) { return QTreeName((d+1)%4); }
inline QTreeName Dist( const QTreeName a, const QTreeName b ) { return QTreeName((a-b+4)%4); }

#endif	/* __NAMES_H__ */
