// -*- Mode: c++ -*-
// $Id: Perms.cpp,v 1.4 2000/04/28 22:14:46 ps Exp $
// $Source: /ufs/multires/projects//src/CourseQuad/Perms.cpp,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech) 
 *
 * April 26, 2000
 * All Rights Reserved
 * 
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 * 
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#include "Perms.h"

// if you really want to know, draw a picture of the compass rose and
// consider one neighbor; now consider all ratitions and reflections of
// that neighbor. That's the table. The resulting integers are the names
// of the permutations (see the tables below).
// for example: Let me go west with no reflection. if I find east on the
// other side, then the orientations are identical (the zero permutation);
// you'll find this in [1][W][E] == [1][1][3], etc.
int
Perms::m_Ptbl[2][4][4] =
// the reflected guys
{ { { 6, 7, 4, 5 },
    { 7, 4, 5, 6 },
    { 4, 5, 6, 7 },
    { 5, 6, 7, 4 } },
// the non-reflected guys
  { { 2, 1, 0, 3 },
    { 3, 2, 1, 0 },
    { 0, 3, 2, 1 },
    { 1, 0, 3, 2 } } };

Direction 
Perms::m_dp[8][4] =
{
  //N, W, S, E
  { N, W, S, E }, // 0
  { E, N, W, S }, // 1
  { S, E, N, W }, // 2
  { W, S, E, N }, // 3
  { N, E, S, W }, // 4
  { W, N, E, S }, // 5
  { S, W, N, E }, // 6
  { E, S, W, N }  // 7
};

QTreeName 
Perms::m_qtnp[8][4] =
{
  //NW, SW, SE, NE
  { NW, SW, SE, NE }, // 0
  { NE, NW, SW, SE }, // 1
  { SE, NE, NW, SW }, // 2
  { SW, SE, NE, NW }, // 3
  { NE, SE, SW, NW }, // 4
  { NW, NE, SE, SW }, // 5
  { SW, NW, NE, SE }, // 6
  { SE, SW, NW, NE }  // 7
};

