// -*- Mode: c++ -*-
// $Id: Subdiv.cpp,v 1.10 2000/04/28 22:14:47 ps Exp $
// $Source: /ufs/multires/projects//src/CourseQuad/Subdiv.cpp,v $

/**
 * Copyright 1995-2000, Peter Schr\"oder, California Institute of
 * Technology (Caltech) 
 *
 * April 26, 2000
 * All Rights Reserved
 * 
 * The use of this software is permitted for non-commercial, educational,
 * and research use only. The software and/or related materials are
 * provided "as-is" without warranty of any kind including any warranties
 * of performance or merchantability or fitness for a particular use or
 * purpose (as set forth in UCC 23212-2313) or for any purpose
 * whatsoever, for the licensed product, however used. In no event shall
 * Caltech be liable for any damages and/or costs, including but not
 * limited to incidental or consequential damages of any kind, including
 * economic damage or injury to property and lost profits, regardless of
 * whether Caltech shall be advised, have reason to know, or in fact
 * shall know of the possibility. User bears all risk relating to quality
 * and performance of the software and/or related materials.
 * 
 * Any use other than non-commercial, educational, or research, or any
 * redistribution in original or modified form requires prior written
 * authorization from the copyright holder.
 */

#include <string.h>
#include <stdio.h>

#include "CMesh.h"
#include "compat.h"

const char *usage = "dual #_of_level DS|ME|BIQ [eps]\n\tinput is expected on stdin and output goes to stdout\n\tif a positive eps controls adaptive subdivision\n";

int
main(int argc, char ** argv)
{
  if( argc < 3 ){
    cerr << usage;
    exit(1);
  }
  const int levels = atoi(argv[1]);
  const Scheme sch = !strcmp( argv[2], "ME" )? ME : (!strcmp(argv[2],"BIQ")? BIQ : DS );

  CMesh mesh(sch);
  if( !readIVFile( stdin, mesh ) ){
    cerr << usage;
    exit(1);
  }
  mesh.Subdiv( levels, argc == 4 ? atof(argv[3]) : -1 );
  cout << mesh;
  
  return 0;
}

